macroScript Stereographer category:"Render Tools" tooltip:"Launch Stereographer Max" icon:#("BPPicons",2)
(


-- EditorTabWidth = 4  for best viewing
---------------------------------------------------------------
-- 
-- Stereographer Max v0.95j
--  	for 3DS Max r4 and 5
-- Stereo format and Color Anaglyph Generator
-- designed and colorized by Ron K. Lussier  - rlussier@csi.com
-- Coded by Ron Lussier and Larry Minton
-- 
-- based on a "simple Stereo View utility" script
--  by Jaroslaw M. Iwanski 
-- 
---------------------------------------------------------------
-- 
-- For .jps file viewing download Vrex's DepthCharge viewer at
--    www.vrex.com/depthcharge/
-- or the Stereo viewer Java Applet at
-- 
-- 
-- No guarantees are implied, use this software at your own risk.
-- 
-- Please forgive the mess I'm not a programmer
-- (Thanks to Larry M for all the CLEAN code!)
-- 
-- 	Copyleft 2000-2003 Ron K Lussier
-- 	Please leave the above information in any future version
-- 	of this script.
-- 
-- 	Enjoy!	
-- 
-- 
---------------------------------------------------------------


-- global variables
Global	floatSm=undefined, sourceCam, userFile, systemFile, userSat=75, userGam=1.2, pixelShift, LeftEye, RightEye, \
		sourceCamHandlerName, sourceCamHandlerDeleted, Stereo_Images, helpDir=getDir #help

--global functions
Global	renderFrame, ProcessMultipleFrames, ProcessOneFrame, Composite_Pair, Composite_Anaglyph, \
		Composite_SideBySide, Composite_TopBottom, Composite_Interlaced, ReComposite, \
		FileType_isStereo, FileType_isMultiFrame, Change_Extension, Change_Extension_Back, \
		create_cameras, camPickerFilter, ZeroFill, strcase, round_to, eye_files_exist, undisplayall, \
		load_init, save_init
		
struct Stereo_Camera (left, right)
struct Stereo_Pair (left, right, composite)


--
-- The main interface rollout
----------------- 

  rollout smPanel "S t e r e o g r a p h e r   M a x"
  (
		
	group "Camera Settings"
	(
		label cs1 "Pick Master Camera:" align:#left offset:[0,0] across:2
		label cs2 "Interocular Distance (units):" align:#left offset:[2,0]
        pickbutton pickCam "none" tooltip:"Choose Camera" width:90 \
				offset:[-15,-3] message:"Choose a camera:" filter:camPickerFilter across:2
		spinner interocular  range:[0.1,1000,6] offset:[6,-1] width:50 align:#center

		progressBar  animProg  width:220 height:7 align:#center offset:[0,-1]
		progressBar renderProg width:220 height:7 align:#center offset:[0,-5]
		button go "Render Stereo Image(s)" enabled:false width:130 offset:[0,-6] \
				tooltip:"Start rendering frames"
	)

	group "Compositing"
	(
		checkbox compositeOn "On" checked:true  align:#left offset:[-4,-6] enabled:false
		label smJPS "**JPS file**"				align:#center offset:[-36,-15] enabled:false
		radiobuttons compType labels:#("Anaglyph", "Pair", "Top/Bot", "Interlace") default:1 columns:4 \
												align:#left offset:[-3,-2]
		label smC0 "Right Image is:" 			align:#left offset:[40,4]
		radiobuttons rightFirstOn labels:#("Cyan/1st", "Red/2nd") default:1 columns:2 \
												align:#right offset: [4,-17]
		spinner imageOffset "Image Offset %: "  range:[0,30,5] type:#float \
												width:68 offset:[12,7] align:#left
		label smC1 "( 3D Depth Placement )" 	offset:[-10,-20] align:#right
		label smC2 "( Anaglyph Controls )"		offset:[0,9] enabled:true align:#left
		spinner adjustSat "Saturation %: "		range:[0,100,75] type:#float enabled:true \
												scale:1.0 width:95 align:#right across:2
		spinner setGamma "Gamma: " 				type:#float range:[0.1,4,1.2] \
												align:#right width:80 offset:[0,-1]
		button reComp "Re-Composite Last Still" height:17 enabled:false offset:[0,6] \
												tooltip:"Uses last 'Frame' image pair"
	)
	
	group "File Output"
	(
		radiobuttons animateOn labels:#("Frame     ", "Animation") offset:[2,9] default:1 align:#left
		spinner startFrame "Start:" range:[0,9000,0] enabled:false \
									 type:#integer width:80 align:#right offset:[-2,-31]
													-- default:animationRange.start.frame]
		spinner endFrame "End:" 	 range:[0,9000,30] enabled:false \
									 type:#integer width:78 align:#right offset:[-2,0]
													-- default:animationRange.end.frame]
		
		label cs3 "Render Size:" align:#left offset:[-2,-3]
		spinner rendWidth "Width:" range:[4,9000,(renderWidth)] type:#integer \
									width:86 offset:[20,0] align:#left
		spinner rendHeight "Height:" range: [4,9000,(renderHeight)] type:#integer \
									width:90 offset:[16,-2] align:#left		
		spinner csAspect "Aspect:" range:[.0001,10,(renderWidth as float/ \
									renderHeight as float*renderPixelAspect)] scale:0.01 \
									width:62 align:#right offset:[-30,-41] 
		checkbox csAspectLock "Locked" checked:true align:#right offset:[-18,0]
		
		label fo2 "Output File:" align:#left offset:[0,16]
		button saveAs "none" width:110 offset:[0,-16] tooltip:"Define format and directory for output"
	)

	group "Stereographer Max v0.95"
	(
		label smTop2 "by Ron K. Lussier, Larry Minton && Jaroslaw M. Iwanski" offset:[0,2]
		button help "Help" width:60 offset:[0,4] tooltip:"Open Stereo Help file"
	)

	-- End of Interface
------------------------


-- On/Do...
	
	-- old implementation idea, doesn't do anything yet, disabled
	on compositeOn changed state do
	(	if (not compositeOn.checked)
		 then ( userGam=smPanel.setGamma.value; userSat=smPanel.adjustSat.value;
		 		smPanel.compType.enabled=false; smPanel.rightFirstOn.enabled=false; 
		 		smPanel.smJPS.enabled=false; smPanel.setGamma.enabled=false; smPanel.setGamma.value=1.0;
				smPanel.adjustSat.enabled=false; smPanel.adjustSat.value=100; smPanel.smC2.enabled=false
			  )
		 else ( smPanel.adjustSat.value=userSat; smPanel.setGamma.value=userGam;
				smPanel.compType.enabled=true; smPanel.setGamma.enabled=true;
		 		smPanel.adjustSat.enabled=true; smPanel.smC2.enabled=true;
		 		smPanel.rightFirstOn.enabled=true;
		 		
				(if smPanel.rightFirstOn.state == 1 and smPanel.compType.state == 2
				 do smPanel.smJPS.enabled=true)
		 	  )
	)
	-- 
	
	
	on compType changed state do
	(	if (not smPanel.compType.state == 1)
		 then (
		 		(if (not smPanel.setGamma.value == 1.0) and (not smPanel.adjustSat.value == 100) do
		 		 (userGam=smPanel.setGamma.value; userSat=smPanel.adjustSat.value)
				);
				smPanel.setGamma.value=1.0; smPanel.adjustSat.value=100; 
				smPanel.adjustSat.enabled=false; smPanel.smC2.enabled=false;
				if smPanel.compType.state == 2 then
				 (	 if smPanel.rightFirstOn.state == 1
					  do smPanel.smJPS.enabled=true
				 ) else smPanel.smJPS.enabled=false
			  )
		 else (smPanel.adjustSat.enabled=true; smPanel.adjustSat.value=userSat; 
		 		 smPanel.setGamma.value=userGam;
				 smPanel.smC2.enabled=true; smPanel.smJPS.enabled=false
			  )
		smPanel.rightFirstOn.enabled=true
	)
	
	on rightFirstOn changed state do
	(
		if (smPanel.rightFirstOn.state == 1) and (smPanel.compType.state == 2)
		 then smPanel.smJPS.enabled=true
		 else smPanel.smJPS.enabled=false
	)

	on animateOn changed state do
	(	if smPanel.animateOn.state == 1
		 then (smPanel.startFrame.enabled=false; smPanel.endFrame.enabled=false)
		 else (smPanel.startFrame.enabled=true; smPanel.endFrame.enabled=true)
	)
	
	on csAspect changed newAspect do
		(smPanel.rendHeight.value=smPanel.rendWidth.value/newAspect+.5
		 renderHeight=smPanel.rendWidth.value/newAspect+.5
		)

	on rendHeight changed newHeight do
	(	if smPanel.csAspectLock.checked
		 then (smPanel.rendWidth.value=newHeight*smPanel.csAspect.value+.5
		 	  renderHeight = (newHeight as integer)
			  renderWidth = newHeight*smPanel.csAspect.value+.5
			  )
		 else (smPanel.csAspect.value=smPanel.rendWidth.value as float/newHeight as float
		 	  renderHeight = (newHeight as integer)
			  )
	)

	on rendWidth changed newWidth do
	(	if smPanel.csAspectLock.checked
		 then (smPanel.rendHeight.value=newWidth/smPanel.csAspect.value+.5
		 	  renderWidth = (newWidth as integer)
			  renderHeight = newWidth/smPanel.csAspect.value+.5
			  )
		 else (smPanel.csAspect.value=newWidth as float/smPanel.rendHeight.value as float
		 	  renderWidth = (newWidth as integer)
			  )
	)

	on saveAs pressed do
	(	userFileIn=getSaveFileName filename:(userFile) caption:"Save Anaglyph File As..." \
			types:("Bitmap(*.bmp)|*.bmp|Windows AVI(*.avi)|*.avi|Flic(*.flc)|*.flc|GIF(*.gif)|*.gif|JPEG(*.jpg)|*.jpg|Stereo JPEG(*.jps)|*.jps|" +
					"TIFF(*.tif)|*.tif|PNG(*.png)|*.png|Stereo PNG(*.pns)|*.pns|RLA(*.rla)|*.rla|QuickTime(*.mov)|*.mov|Targa(*.tga)|*.tga|All Files|*.*|")

		--LAM: added code to retain old userFile if user cancels out of GetSaveFileName
		if (userFileIn != undefined) do userFile = userFileIn
		if (userFile != undefined) then
		(	smPanel.saveAs.text=filenameFromPath userFile
	 		if (smPanel.pickCam.text != "none") do smPanel.go.enabled = true
			if eye_files_exist() do reComp.enabled = true
			systemFile=userFile
			if FileType_isStereo (getFilenameType userFile) do
			(
				Change_Extension ()
				smPanel.compType.state=2; smPanel.rightFirstOn.state=1;
				smPanel.rightFirstOn.enabled=false; smPanel.smJPS.enabled=true;
				smPanel.adjustSat.enabled=false; smPanel.adjustSat.value=100;
				smPanel.setGamma.value=1.0; smPanel.smC2.enabled=false
			)
		 )
		 else (smPanel.saveAs.text="none"; smPanel.go.enabled=false)
	)

	on pickCam picked cam do 
	( 	sourceCam = Cam
		smPanel.pickCam.text = Cam.name
		--vpSetup.makePair.enabled=true 
		if (smPanel.saveAs.text != "none") do smPanel.go.enabled = true

--LAM: added in ChangeHandlers to handle sourceCam renaming/deletion
		if (sourceCamHandlerName != undefined) do deleteChangeHandler sourceCamHandlerName
		if (sourceCamHandlerDeleted != undefined) do deleteChangeHandler sourceCamHandlerDeleted
		sourceCamHandlerName=when name sourceCam changes do smPanel.pickCam.text = sourceCam.name
		sourceCamHandlerDeleted=when sourceCam deleted do 
		(	smPanel.pickCam.text = "none"
			--vpSetup.makePair.enabled=false
			smPanel.go.enabled = false
			deleteChangeHandler sourceCamHandlerDeleted
			deleteChangeHandler sourceCamHandlerName
			sourceCamHandlerDeleted=undefined
			sourceCamHandlerName=undefined
		)
	)

	on reComp pressed do
	(	
--LAM redid test to make sure files are present. got rid of argument in reComposite since it is not used.
		if eye_files_exist() then 
			ReComposite ()
		else
			reComp.enabled=false
	)

    on go pressed do
	(	
		save_init()
		if isDeleted sourceCam do
		(
			if (viewport.GetCamera() != undefined) then
			(
				sourceCam = viewport.GetCamera()
				-- ??> sourceCam = Cam
				smPanel.pickCam.text = sourceCam.name
				--vpSetup.makePair.enabled=true 
				if (smPanel.saveAs.text != "none") do smPanel.go.enabled = true
			)
			else 
			(
			  smPanel.pickCam.text = "none"
			  smPanel.go.enabled = false
			  messageBox "The defined Camera has been deleted, please pick a new Camera." title:"No such Camera" beep:true
			)
		)
		if (smPanel.pickCam.text != "none") and (smPanel.saveAs.text != "none") do
		(
			renderEffects=true
			pixelShift = (round_to (smPanel.imageOffset.value * smPanel.rendWidth.value / 100) 0) as integer
			Stereo_Cameras = create_cameras sourceCam animated:(smPanel.animateOn.state == 2)
			Stereo_Images=Stereo_Pair()
			undisplayall Stereo_Images
			Stereo_Images.left=bitmap (smPanel.rendWidth.value+pixelShift)\
					smPanel.rendHeight.value
			Stereo_Images.right=bitmap (smPanel.rendWidth.value+pixelShift)\
					smPanel.rendHeight.value
	
			if smPanel.animateOn.state == 1 then
			(	status=ProcessOneFrame Stereo_Cameras Stereo_Images
				if status do reComp.enabled = true
			)
			else
			ProcessMultipleFrames Stereo_Cameras Stereo_Images
				
			delete Stereo_Cameras.left
			delete Stereo_Cameras.right
			-- close Stereo_Images.composite
			messageBox "Stereo Render Complete!" title:"Finished" beep:true
		)
	)

	-- Create and Close extra Rollouts, clear change handlers if present
	on smPanel open do
	(
		-- addRollout vpSetup smPanel rolledUp:true
		-- addRollout aboutbox smPanel rolledUp:false
		try
		(	deleteChangeHandler sourceCamHandlerDeleted
			deleteChangeHandler sourceCamHandlerName
		)
		catch ()
		sourceCamHandlerDeleted=undefined
		sourceCamHandlerName=undefined
		if $APCamera_Left != undefined do delete $APCamera_Left
		if $APCamera_Right != undefined do delete $APCamera_Right

		-- Get camera from currently active viewport
		if (viewport.GetCamera() != undefined) do
		(
		 sourceCam = viewport.GetCamera()
		 -- ??> sourceCam = Cam
		 smPanel.pickCam.text = sourceCam.name
		 --vpSetup.makePair.enabled=true 
		 if (smPanel.saveAs.text != "none") do smPanel.go.enabled = true
		)
		
		-- Get default file output name
		userFile = ((GetDir #image)+("\\stereo.bmp"))
		if (userFile != undefined) then
		(	smPanel.saveAs.text=filenameFromPath userFile
	 		if (smPanel.pickCam.text != "none") do smPanel.go.enabled = true
			if eye_files_exist() do reComp.enabled = true
			systemFile=userFile
			if FileType_isStereo (getFilenameType userFile) do
			(
				Change_Extension ()
				smPanel.compType.state=2; smPanel.rightFirstOn.state=1
				smPanel.rightFirstOn.enabled=false; smPanel.smJPS.enabled=true
				smPanel.adjustSat.enabled=false; smPanel.adjustSat.value=100
				smPanel.setGamma.value=1.0; smPanel.smC2.enabled=false
			)
		 )
		 else (smPanel.saveAs.text="none"; smPanel.go.enabled=false)
		-- messageBox "If you like the program, please contact me to purchase it. - Thank you. - rlussier@csi.com" title:"Stereographer Max demo" 
		load_init()
		if (smPanel.animateOn.state == 2) do
			smPanel.startFrame.enabled=true; smPanel.endFrame.enabled=true
	)
	
	on smPanel close do
	(
		try
		(	deleteChangeHandler sourceCamHandlerDeleted
			deleteChangeHandler sourceCamHandlerName
		)
		catch ()
		sourceCamHandlerDeleted=undefined
		sourceCamHandlerName=undefined
		save_init()
		if classOf vpSetup == RolloutClass then (removeRollout vpSetup)
		if classOf aboutbox == RolloutClass then (removeRollout aboutbox)
	)
	
	on help pressed do
	(
		ShellLaunch (helpDir + "\\StereoG.chm") ""
	)
	
)


-- Little Functions
-------------------
fn camPickerFilter anObject = 
(
    if superclassof(anObject)==camera then true else false
)

fn round_to val n = 
(
    local mult = 10.0 ^ n
	(floor ((val * mult) + 0.5)) / mult
)

-- RKL: stole Bobo's save and load init file routines
fn save_init =
(
	out_file = createfile (scriptspath+"\\stereog.ini")
	format "%\n" "Stereographer Max Settings" to:out_file 
	format "%\n" "Version 0.95" to:out_file 
	format "%\n" (smPanel.interocular.value as string) to:out_file 
	format "%\n" (smPanel.compType.state as string) to:out_file 
	format "%\n" (smPanel.rightFirstOn.state as string) to:out_file 
	format "%\n" (smPanel.imageOffset.value as string) to:out_file 
	format "%\n" (smPanel.adjustSat.value as string) to:out_file 
	format "%\n" (smPanel.setGamma.value as string) to:out_file 
	format "%\n" (smPanel.animateOn.state as string) to:out_file 
	format "%\n" (smPanel.startFrame.value as string) to:out_file 
	format "%\n" (smPanel.endFrame.value as string) to:out_file 
	close out_file
)

fn load_init =
(
	try
	(
		in_file = openfile (scriptspath+"\\stereog.ini")
		str = readline in_file
		str = readline in_file
		smPanel.interocular.value = execute (readline in_file)
		smPanel.compType.state = execute (readline in_file)
		smPanel.rightFirstOn.state = execute (readline in_file)
		smPanel.imageOffset.value = execute (readline in_file)
		smPanel.adjustSat.value = execute (readline in_file)
		smPanel.setGamma.value = execute (readline in_file)
		smPanel.animateOn.state = execute (readline in_file)
		smPanel.startFrame.value = execute (readline in_file)
		smPanel.endFrame.value = execute (readline in_file)
		close in_file 
	)
	catch
	()
)

--LAM: added function for testing if left and right eye view files exist
fn eye_files_exist =
(
	((getfiles (getFilenamePath userFile + "lastLeft.bmp")).count +
	 (getfiles (getFilenamePath userFile + "lastRght.bmp")).count) == 2
)

--LAM: added string case conversion routine
fn strcase instring cnv_case =
(	local toCase, fromCase, upper, lower, i, j, outstring
	upper="ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	lower="abcdefghijklmnopqrstuvwxyz"
	outstring=copy instring
	if (cnv_case == 1)	then (fromCase=upper; toCase=lower)
						else (fromCase=lower; toCase=upper)
	for i=1 to outstring.count do
	(	j=findString fromCase outstring[i]
		if (j != undefined) do outstring[i]=toCase[j]
	)
	return outstring
)

--LAM: added function for testing if output file type is multiframe.
fn FileType_isMultiFrame FileType =
(	case (strcase FileType 1) of
	(	".avi":		true
		".flc": 	true
		".mov":		true
		default:	false
	)
)

--RKL: added function for testing if output file type is new stereo format.
fn FileType_isStereo FileType =
(	case (strcase FileType 1) of
	(	".jps":		true
		".pns": 	true
		default:	false
	)
)

-- RKL: added function for changing to 'real' systemFile extension if writing to jps or pns formats
fn Change_Extension =
(
	if getFilenameType userFile == ".jps"
	 do systemFile=getFilenamePath userFile + getFilenameFile userFile + ".jpg"
	if getFilenameType userFile == ".pns"
	 do systemFile=getFilenamePath userFile + getFilenameFile userFile + ".png"
)

-- RKL: added function to rename file extension to jps or pns after saving
fn Change_Extension_Back =
(	if FileType_isStereo (getFilenameType userFile) do
	(	deleteFile  (getFilenamePath userFile + getFilenameFile userFile + getFilenameType userFile)
		renameFile  (getFilenamePath userFile + getFilenameFile userFile + getFilenameType systemFile) \
					(getFilenamePath userFile + getFilenameFile userFile + getFilenameType userFile)
	)
)

--LAM: added function that takes an integer and returns a n character string, zero filled (0001, etc...)
fn ZeroFill val n =
(	s_val=val as string
	out_string=""
	for j=1 to n do out_string += "0"
	for i = s_val.count to 1 by -1 do 
	(	out_string[n]=s_val[i]
		n -= 1
	)
	return out_string
)

--LAM: added function to close open displays
fn undisplayall Stereo_Images=
(	if Stereo_Images.left != undefined do undisplay Stereo_Images.left
	if Stereo_Images.right != undefined do undisplay Stereo_Images.right
	if Stereo_Images.composite != undefined do undisplay Stereo_Images.composite
	if Stereo_Images.composite != undefined do undisplay Stereo_Images.composite
)

--LAM: added function to save a copy of a bitmap (used to keep displays open during
--	bitmap close)
fn SaveImageCopy image =
(	temp_image=copy image
	temp_image.filename=image.filename
	-- if (image == Stereo_Images.composite and smPanel.animateOn.state==2) then save temp_image frame:currentTime else 
	save temp_image
	close temp_image
)

---- Main Functions ----
------------------------
fn ReComposite =
--LAM: closing files after reading. Was hanging if files weren't closed. MAXScript bug?
-- Re-Load the two expanded image renders
(	Stereo_Images=Stereo_Pair()
	Stereo_Images.left= openBitmap (getFilenamePath userFile + "lastLeft.bmp")
	close Stereo_Images.left
	Stereo_Images.right=openBitmap (getFilenamePath userFile + "lastRght.bmp")
	close Stereo_Images.right
	pixelShift = (round_to (smPanel.imageOffset.value * smPanel.rendWidth.value / 100) 0) as integer
	Stereo_Images.composite=bitmap \
		((smPanel.rendWidth.value)*(if smPanel.compType.state==2 then 2 else 1)) \
		((smPanel.rendHeight.value)*(if smPanel.compType.state==3 then 2 else 1)) \
		gamma:smPanel.setGamma.value fileName:systemFile 
	-- Composite appropriate format
	Composite_Pair ()
	SaveImageCopy Stereo_Images.composite
	Change_Extension_Back ()
)

--LAM: pulled up common camera creation code into function. Creating the cameras as copies 
-- of the source camera and then converting them to free cameras
fn create_cameras sourceCam animated:false =
(
	Animate off
	(			
		-- create Cameras
		Cam = Stereo_Camera()
		Cam.left= copy sourceCam 
--LAM: create a dummy just to grab it's (non-animated) PRS controller
		deleteme=dummy()
		Cam.left.transform.controller= deleteme.transform.controller
		delete deleteme
		max hide helper toggle
		Cam.left.transform= sourceCam.transform
		Cam.right= copy Cam.left

		-- name them, for the sake of the display window
		Cam.left.name= "SM Camera Left"
		Cam.right.name="SM Camera Right"

		-- Adjust FOV since some pixels are dropped in Composite phase
		if (animated and (sourceCam.fov.isAnimated))then
		(	numFOVkeys=numkeys sourceCam.fov.controller
			for i=1 to numFOVkeys do
			(	t=getKeyTime sourceCam.fov.controller i
				at time t, animate on 
				(	Cam.left.fov	+= sourceCam.fov*(smPanel.imageOffset.value/100)
					Cam.right.fov	= Cam.left.fov
				)
			)
		)
		else
		(	Cam.left.fov	+= sourceCam.fov*(smPanel.imageOffset.value/100)
			Cam.right.fov	= Cam.left.fov
		)

		-- Offset the cameras to Eye Distance, in local Camera coordinates
		in coordsys sourceCam Cam.left.pos.x	-=(smPanel.interocular.value*0.5)
		in coordsys sourceCam Cam.right.pos.x	+=(smPanel.interocular.value*0.5)

		-- link it up
		Cam.left.parent=sourceCam
		Cam.right.parent=sourceCam
		
		return Cam
	)
)

fn ProcessOneFrame Stereo_Cameras Stereo_Images =
(	
	Stereo_Images.composite=bitmap \
	 ((smPanel.rendWidth.value)*(if smPanel.compType.state==2 then 2 else 1)) \
	 ((smPanel.rendHeight.value)*(if smPanel.compType.state==3 then 2 else 1)) \
	 gamma:smPanel.setGamma.value fileName:systemFile 

	undisplayall Stereo_Images
	status=renderFrame Stereo_Cameras Stereo_Images
	if (status) do 
	(	Stereo_Images.left.fileName=(getFilenamePath userFile + "lastLeft.bmp")
		SaveImageCopy Stereo_Images.left
		Stereo_Images.right.fileName=(getFilenamePath userFile + "lastRght.bmp")
		SaveImageCopy Stereo_Images.right
	 	SaveImageCopy Stereo_Images.composite
		Change_Extension_Back ()
	)
	return status
)


fn ProcessMultipleFrames Stereo_Cameras Stereo_Images =
(	undisplayall Stereo_Images
	MultiFrame=FileType_isMultiFrame (getFilenameType systemFile)
	if MultiFrame then
	(	Stereo_Images.composite=bitmap \
			(if smPanel.compType.state==2 then (smPanel.rendWidth.value*2) else (smPanel.rendWidth.value))\
			((smPanel.rendHeight.value)*(if smPanel.compType.state==3 then 2 else 1)) \
			filename:systemFile gamma:smPanel.setGamma.value \
			numframes:(smPanel.endFrame.value-smPanel.startFrame.value+1)
		save Stereo_Images.composite
	)
	else 
	(	Stereo_Images.composite=bitmap \
		 ((smPanel.rendWidth.value)*(if smPanel.compType.state==2 then 2 else 1)) \
		 ((smPanel.rendHeight.value)*(if smPanel.compType.state==3 then 2 else 1)) \
		  filename:systemFile gamma:smPanel.setGamma.value
	)
	save Stereo_Images.composite
	
	frame_num=0
	smPanel.animProg.value = 0
	for i = smPanel.startFrame.value to smPanel.endFrame.value do
	(	t = i-smPanel.startFrame.value
		smPanel.animProg.value = 100*t/(smPanel.endFrame.value-smPanel.startFrame.value+1)
		sliderTime=i
		if (not MultiFrame) do 
		--	Stereo_Images.composite.filename=userFile
			Stereo_Images.composite.filename=(getFilenamePath userFile + getFilenameFile userFile + (ZeroFill i 4) + getFilenameType systemFile)
		at time i if (not (renderFrame Stereo_Cameras Stereo_Images)) do exit
		if (not MultiFrame) then
			(SaveImageCopy Stereo_Images.composite; Change_Extension_Back ())
		else
			save Stereo_Images.composite
		frame_num += 1
	)
	if (MultiFrame) do 
	(	close Stereo_Images.composite
		display Stereo_Images.composite
	)
	smPanel.animProg.value = 0
)

------------------------
-- Render a frame
---------------------------
fn renderFrame Stereo_Cameras Stereo_Images = 
(
--LAM: added "cheat" to detect if the render was canceled. Creating bitmaps before the rendering,
--     and set the very last pixel to an "illegal" value. After the render, see if this pixel's
--	   value has changed.

	MultiFrame=FileType_isMultiFrame (getFilenameType systemFile)
	width=smPanel.rendWidth.value+pixelShift
	height=smPanel.rendHeight.value
	illegal_Color=[-1,-1,-1] as color

	smPanel.renderProg.value = 12
	
	-- Render two expanded images
	setPixels Stereo_Images.left [width-1,height-1] #(illegal_Color)
	render camera:Stereo_Cameras.left progressBar:off to:Stereo_Images.left
	if ((getPixels Stereo_Images.left [width-1,height-1] 1)[1].r > 255.) do return false

	smPanel.renderProg.value = 40

	setPixels Stereo_Images.right [width-1,height-1] #(illegal_Color)
	render camera:Stereo_Cameras.right progressBar:off to:Stereo_Images.right
	if ((getPixels Stereo_Images.right [width-1,height-1] 1)[1].r > 255.) do return false

	smPanel.renderProg.value = 70

	Composite_Pair ()
)

-- Get pixel data and composite each line in appropriate format
fn Composite_Pair =
(
	--LAM: Work with copies so the original images aren't de-saturated in anaglyph composite
	LeftEye=copy Stereo_Images.left
	RightEye=copy Stereo_Images.right
	 	
    for y=0 to ( if smPanel.compType.state==3 then 
				  (LeftEye.height*2)
				  else LeftEye.height
				) do
	(	if (mod y (LeftEye.height/10))==0 do display Stereo_Images.composite
	
		if (mod y (LeftEye.height/10))==0 do 
			(if smPanel.compType.state == 3 then 
			 smPanel.renderProg.value = ((100.0*y/(LeftEye.height*2))*0.3)+70 
			 else 
			 smPanel.renderProg.value = ((100.0*y/LeftEye.height)*0.3)+70
			)
		
		-- do appropriate composite routine on each line
		if smPanel.compType.state == 1 do Composite_Anaglyph Stereo_Images y
		if smPanel.compType.state == 2 do Composite_SideBySide Stereo_Images y
		if smPanel.compType.state == 3 do Composite_TopBottom Stereo_Images y
		if smPanel.compType.state == 4 do Composite_Interlaced Stereo_Images y
    )
	
	smPanel.renderProg.value = 0
    display Stereo_Images.composite
	return true
)

-- Composite Anaglyph - single line
-- RKL: Added strange swap of line array length according to whether the ImageOffset
-- has been increased or decreased - to fix an array bug
-----------------------------------
fn Composite_Anaglyph Stereo_Images lineNumber = 
(
	sat_val=(smPanel.adjustSat.value / 100)

    leftEyePixels=getPixels LeftEye [(pixelShift),lineNumber] \
	(if (LeftEye.width-pixelShift < renderWidth) then 
	(LeftEye.width-pixelShift)
	else renderWidth)
    leftEyePixels.s *= sat_val

	rightEyePixels=getPixels RightEye [0,lineNumber] \
	(if (LeftEye.width-pixelShift < renderWidth) then 
	(LeftEye.width-pixelShift)
	else renderWidth)
    rightEyePixels.s *= sat_val
	
	if smPanel.rightFirstOn.state == 1
	then (
			stereoPixels=#()
			for aPixel in 1 to leftEyePixels.count do
			(
				stereoPixels[aPixel]=rightEyePixels[aPixel]
				stereoPixels[aPixel].r=leftEyePixels[aPixel].r
			)
		 )
	else (
			stereoPixels=#()
			for aPixel in 1 to leftEyePixels.count do
			(
				stereoPixels[aPixel]=leftEyePixels[aPixel]
				stereoPixels[aPixel].r=rightEyePixels[aPixel].r
			)
		 ) 
	setPixels Stereo_Images.composite [0,lineNumber] stereoPixels
)

-- Composite Cross-eyed Line 
-----------------------------------
fn Composite_SideBySide Stereo_Images lineNumber = 
(
    leftEyePixels=getPixels LeftEye [(pixelShift),lineNumber ] \
	(if (LeftEye.width-pixelShift < renderWidth) then 
	(LeftEye.width-pixelShift)
	else renderWidth)

	rightEyePixels=getPixels RightEye [0,lineNumber ] \
	(if (LeftEye.width-pixelShift < renderWidth) then 
	(LeftEye.width-pixelShift)
	else renderWidth)

	-- Cross-Eyed composite else FreeView composite
	if smPanel.rightFirstOn.state == 1
	then (setPixels Stereo_Images.composite [0,lineNumber ] rightEyePixels
		  setPixels Stereo_Images.composite [renderWidth,lineNumber ] leftEyePixels)
	else (setPixels Stereo_Images.composite [0,lineNumber ] leftEyePixels
		  setPixels Stereo_Images.composite [renderWidth,lineNumber ] rightEyePixels)
)

-- Composite Top/Bottom Line 
-----------------------------------
fn Composite_TopBottom Stereo_Images lineNumber = 
(
        leftEyePixels=getPixels LeftEye   [(pixelShift),if (lineNumber <(LeftEye.height))
														then lineNumber 
														else (lineNumber-(LeftEye.height)) \
										  ] \
			(if (LeftEye.width-pixelShift < renderWidth) then 
			(LeftEye.width-pixelShift)
			else renderWidth)

        
		rightEyePixels=getPixels RightEye [0,if (lineNumber <(LeftEye.height))
														then lineNumber 
														else (lineNumber-(LeftEye.height)) \
										  ] \
			(if (LeftEye.width-pixelShift < renderWidth) then 
			(LeftEye.width-pixelShift)
			else renderWidth)

		
		-- Top/Bottom composite else Bottom/Top composite
		if smPanel.rightFirstOn.state == 1
		then (if (lineNumber  < (LeftEye.height))
				then setPixels Stereo_Images.composite [0,lineNumber] rightEyePixels
			 	else setPixels Stereo_Images.composite [0,lineNumber] leftEyePixels
			 )
        else (if (lineNumber < (LeftEye.height))
				then setPixels Stereo_Images.composite [0,lineNumber] leftEyePixels
			 	else setPixels Stereo_Images.composite [0,lineNumber] rightEyePixels
			 )
)

-- Old future Junk...
--		-- for top/bottom only,  was trying to average lines together
--		leftEyePixelsB=getPixels LeftEye [(pixelShift),lineNumber+1] (LeftEye.width-pixelShift)
--		rightEyePixelsB=getPixels RightEye [0,lineNumber+1] (RightEye.width-pixelShift)
--			  -- ?should have "Resample" choice in interface?
--			  if (lineNumber < (LeftEye.height))
--				then stereoPixels=((rightEyePixels[.r.g.b?] + rightEyePixelsB)/2)
--			 	else stereoPixels=((leftEyePixels + leftEyePixelsB)/2)
--		setPixels Stereo_Images.composite [0,lineNumber] stereoPixels


-- Composite Interlaced Lines 
-----------------------------------
fn Composite_Interlaced Stereo_Images lineNumber = 
(
	leftEyePixels=getPixels LeftEye [(pixelShift),lineNumber] \
	(if (LeftEye.width-pixelShift < renderWidth) then 
	(LeftEye.width-pixelShift)
	else renderWidth)
        
	rightEyePixels=getPixels RightEye [0,lineNumber] \
	(if (LeftEye.width-pixelShift < renderWidth) then 
	(LeftEye.width-pixelShift)
	else renderWidth)

	---WARNING WILL ROBINSON: FOLLOWING IS DANGEROUS ON LAST SCAN LINE IF ODD IMAGE HEIGHT SET!!!
	-- Interlaced (Right first) composite else (Left first) composite
	-- add in .1 in next line just to make sure no roundoff error, will point beyond bitmap.
	evenLine= (((mod lineNumber 2)+.1) as integer) == 0
	if smPanel.rightFirstOn.state == 1 then 
	if evenLine do
	 ( setPixels Stereo_Images.composite [0,lineNumber] rightEyePixels
		setPixels Stereo_Images.composite [0,lineNumber+1] leftEyePixels
	 )
	else 
	 if evenLine do
	 ( setPixels Stereo_Images.composite [0,lineNumber] leftEyePixels
		setPixels Stereo_Images.composite [0,lineNumber+1] rightEyePixels
	 )
	 
  )



-- Extra Rollouts at bottom
-------------------------------
	rollout vpSetup "Video Post setup"
	(
		group "Create Camera Pair"
		(
			label cc2 "(Camera must be chosen above)"
			button makePair "Create" width:90 enabled:true
			label cc3 ""
		)
		
		-- Create
		on makePair pressed do
		(	Stereo_Cameras = create_cameras sourceCam animated:true
			-- rename them
			Stereo_Cameras.left.name=sourceCam.name+"_Left_"
			Stereo_Cameras.right.name=sourceCam.name+"_Right_"
			-- vpSetup.makePair.text="Finished!"
		 	--vpSetup.makePair.enabled=false
			messageBox "Camera Pair has been created."
		)
	)
		
	-- About Box Rollout
	rollout aboutbox "About Stereographer Max"
	(
		bitmap logo bitmap:(bitmap 90 50) fileName:"AnaMLogo.bmp"
		label ab1 "Stereographer Max"
		label ab2 "v0.94"
		label ab3 "Color Anaglyph Generator"
		label ab4 "by Ron K. Lussier,"
		label ab5 "Larry Minton,"
		label ab6 "and Jaroslaw M. Iwanski"
		label ab7		
	)


-- Run the floater
------------------

if floatSm != undefined then
								(
								closerolloutfloater floatSm
								floatSm = undefined
								)

floatSm = newRolloutFloater "RKL's Stereographer Max" 305 590 20 40
addRollout smPanel floatSm
addRollout vpSetup floatSm rolledUp:true
-- addRollout aboutbox floatSm rolledUp:false

)
